unit Unit1;
// Simple application to use Mysql
// First version Beta 02.04.18.1
// Designed and adapted by Lafargue.yannick (France) April 2002
// <lafaryan.at3@wanadoo.fr>
// Free application Open source for Win 95, 98, 2000, NT.  !( XP not tested )

// Run on client station with intranet or internet network, without BDE and
// Interbase from delphi, and myodbc from mysql drivers.
// To run only on local station you must install the latest Mysqlodbc drivers.
// actually V2.50.39. ! This application didn't tested in this configuration.

// This free application need libmysql.dll version 3.23.49 (client) and
// Mysql.pas Api version 3.23.49 to run correctly.

// If you have any problems to connect to mysql database, download faq and doc
// at <www.mysql.com>.
// If you have any suggestions for the Api mysql.pas, contact
// Matthias Fichtner <mfichtner@fichtner-meyer.com>.


// ! Information !
// you use this application without warranty at your own risk.
// Mysql.pas Api (C) Fichtner is free distribution without warranty, use it at
// your own risk. You can dowload this open source
// at <http://www.fichtner.net/delphi/mysql/>
// Mysql.pas must be placed on your delphi library directory.
//
// You can download the latest libmysql.dll at <www.mysql.com> or at the same
// web site as mysql.pas Api.
// See GPL licence to use Libmysql.dll at <www.mysql.com>
// LibMysql.dll must be in same directory as your application


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,Menus,Clipbrd,Grids,
  MySql; //->MySQL Client API for Borland Delphi (version 4 and above)
         //  Pascal Interface Unit for libmySQL.dll, the
         //  Client Library for MySQL AB's SQL Database Server
         //  This is a literal translation of relevant parts of MySQL AB's
         //  C header files, mysql.h, mysql_com.h, and mysql_version.h
         //  Copyright (c) 1999-2002 Matthias Fichtner

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Memo2: TMemo;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    Connection1: TMenuItem;
    Connection2: TMenuItem;
    deconnection1: TMenuItem;
    Requte1: TMenuItem;
    send1: TMenuItem;
    Edition1: TMenuItem;
    effacerlechapquery1: TMenuItem;
    effacerlechamp1: TMenuItem;
    Memo1: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    StringGrid1: TStringGrid;
    Label10: TLabel;
    Version1: TMenuItem;
    Show1: TMenuItem;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Serveur1: TMenuItem;
    RefreshLog1: TMenuItem;
    RefreshTables1: TMenuItem;
    RefreshHosts1: TMenuItem;
    RefreshStatus1: TMenuItem;
    Help1: TMenuItem;
    procedure Print_Mysql_error(Msg: string = '');
    procedure Print_Mysql_Version;
    procedure Grid_init;
    Function  Process_result_set(res_set:PMYSQL_RES):boolean;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Connection2Click(Sender: TObject);
    procedure deconnection1Click(Sender: TObject);
    procedure send1Click(Sender: TObject);
    procedure effacerlechapquery1Click(Sender: TObject);
    procedure effacerlechamp1Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure RefreshLog1Click(Sender: TObject);
    procedure RefreshTables1Click(Sender: TObject);
    procedure RefreshHosts1Click(Sender: TObject);
    procedure RefreshStatus1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  // mysql
  Conn: PMYSQL;
  res_set: PMYSQL_RES;
  row: PMYSQL_ROW;
  Field:PMYSQL_FIELD;
  Length_Row:PMYSQL_LENGTHS;


implementation

{$R *.DFM}

 var
 Query,selection_row:string;
 Line:string;
 x,y: longword;
 Connection:boolean;
 Time_out:longint;
 MyHost: string;
 MyUser: string;
 MyPass: string;
 MyDBName : string;

////////////////////////////////////////////////////////

// cration de la grille avec un outil trs simple  utiliser : TstingGrid
procedure Tform1.Grid_init;
begin
 StringGrid1.RowCount:=2;
 StringGrid1.ColCount:=2;
 StringGrid1.DefaultColWidth:=10;
 StringGrid1.DefaultRowHeight:=20;
 StringGrid1.cells[0,0]:='';
 StringGrid1.Cells[1,0]:='';
 StringGrid1.cells[1,1]:='';
end;


// afficher le message d'erreur retourn par le serveur Mysql
procedure Tform1.Print_Mysql_Error(Msg: string = '');
 begin
  // mysql_errno, mysql_error
  if Msg = '' then Msg := Format('%d - %s', [mysql_errno(Conn),
                                 mysql_error(Conn)]);
  memo1.lines.Add(Msg);
  memo1.lines.add('=======================================');
  memo2.setfocus;
end;


// aprs s'tre connect obtenir les informations Mysql que l'on veut
// ici on veut tout!
procedure TForm1.Print_Mysql_Version;
 begin
 memo1.Lines.Add('|Mysql informations|');
 memo1.Lines.Add('.==================.');
 memo1.Lines.Add('Mysql Server version : ' + mysql_get_server_info(Conn));
 memo1.Lines.Add('Mysql Client version : ' + mysql_get_client_info);
 memo1.Lines.Add('Protocol: ' + intToStr(mysql_get_proto_info(Conn)));
 memo1.Lines.Add('Host : ' + mysql_get_host_info(Conn));
 if mysql_stat(conn) = nil then print_mysql_error
  else memo1.Lines.Add('Mysql stat: ' + mysql_stat(Conn));
 memo1.lines.add('=======================================');
end;



// traitement des donnes
Function Tform1.process_result_set(res_set:PMYSQL_RES):boolean;
var i,j,length_col:longword;
begin

 // initialisation des colonnes
 
 length_col:=0;
 x:=1;
 mysql_field_seek(res_set,0);
 for i:=0 to mysql_num_fields(res_set)-1 do begin
  field:=mysql_fetch_field(res_set);
  length_col:=length(field.name);
   if length_col < field.max_length then length_col:=field.max_length;
  field.max_length:=length_col + 2;  // ajouter 2 espaces

   if x > 1 then stringgrid1.Colcount:=x+1;
  stringgrid1.ColWidths[X]:=6 * field.max_length; //length_row[i];
  stringgrid1.cells[x,0]:=field.name;
  inc(x);
 end;


 y:=1;
 row:=mysql_fetch_row(res_set);

 while row <> nil do begin
  mysql_field_seek(res_set,0);
  x:=1;
  for i:= 0 to mysql_num_fields(res_set)-1 do begin  // traitement des lignes
   field:=mysql_fetch_field(res_set);
    // analyse et vrifie chaque ligne
   if row[i] = nil then line:='Null'
   else line:=row[i];
    stringgrid1.cells[x,y]:=line;
   inc(x);
  end;
  if y > 1 then stringgrid1.RowCount:=y+1;
  inc(y);
 row:=mysql_fetch_row(res_set);
 end;

 if mysql_errno(conn) <> 0 then result:=false else result:=true;

end;



// init appli
procedure TForm1.FormCreate(Sender: TObject);
begin
Connection:=false;
end;



// se dconnecter de mysql et terminer la session avant de fermer l'appli
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if connection then mysql_close(Conn);
end;



// se connecter  Mysql
procedure TForm1.Connection2Click(Sender: TObject);
begin

 //if connection then exit;

 Grid_init;  // initialisation du tableau

 // pour une connexion locale saisir 'localhost'
 if edit1.text='' then begin
  MessageDlg(' Le champ Hte est vide ', mtError,  [mbOk], 0);
  edit1.setfocus;
  exit;
 end;

 if edit4.text='' then begin
  MessageDlg(' Le champ Database est vide ', mtError,  [mbOk], 0);
  edit4.setfocus;
  exit;
 end;

memo1.lines.add('connexion in process...');

MyHost:=edit1.text;
Myuser:=edit2.text;
Mypass:=edit3.text;
Mydbname:=edit4.text;


Conn := mysql_init(nil);

  if Conn = nil then begin Print_Mysql_Error('Couldn''t init PMYSQL object');
   exit;
  end;

   // options de connexion Timeout
   Time_out:=10;  // 10 secondes 
  if Mysql_options(conn,Mysql_Opt_Connect_Timeout, Pchar(inttostr(Time_out)))
   <> 0 then print_Mysql_error('option inconnue : Mysql_opt_Timeout');

   // mysql_connect
  if mysql_real_connect(Conn, pChar(MyHost), pChar(MyUser), pChar(MyPass),
                          pchar(Mydbname), 0, nil, 0) = nil
  then begin
   Print_Mysql_Error;
   exit;
  end;

 memo1.Lines.Add('');
 memo1.lines.add('Connected to MySQL server at ' + mysql_get_host_info(Conn));

 // information de base sur le socket /!\ a la manipulation Tsocket (WinSok)
 // vous pouvez intervenir mais uniquement si vous te un Pro !
 memo1.lines.add('Info WinSok my_socket '+inttostr(conn.net.fd));

 Print_Mysql_Version;
 connection:=true;
end;



// deconnexion
procedure TForm1.deconnection1Click(Sender: TObject);
begin
if not connection then exit;
memo1.lines.add('disconnected');
memo1.lines.add('=======================================');
mysql_close(Conn);
connection:=false;
end;



// requte Mysql
procedure TForm1.send1Click(Sender: TObject);
var i,j,k,l:longint;
begin

 if not connection then begin memo2.setfocus;
   MessageDlg('Le serveur Mysql est dconnect.', mtError,
      [mbOk], 0);
 exit;
 end;

 // petit traitement du champ de saisie Query

 if memo2.lines.count = 0 then begin memo2.setfocus; exit; end;

 l:=0;j:=0;

 for i:=0 to memo2.lines.count-1 do begin
  if memo2.lines.Strings[i] ='' then inc(j) // ligne vide ou CR
   else begin
    for k:=1 to length(memo2.lines.Strings[i]) do
     if memo2.lines.Strings[i][k] = ' ' then inc(l); // vide ou espace
    if l = length(memo2.lines.strings[i]) then inc(j);// idem sans CR
    if (l = length(memo2.lines.Strings[1])-2) and (l >0)
     then inc(j); // idem avec CR
    l:=0;
   end;
 end;
 // si rien alors rien ! /!\ ici on a pas vrifi si la commande tait correcte
 if j = memo2.lines.count then begin memo2.clear; memo2.setfocus; exit end;

 Query:=memo2.lines.Text;

 memo1.lines.add(Query);

 Grid_init;

 // executer la requte

 if mysql_real_query(conn,pchar(query), length(query)) <> 0 then begin
  Print_Mysql_Error;
  exit;
 end;

 res_set:=mysql_store_result(conn);

 if res_set = nil then begin     // erreur retourne ou info !
  if Mysql_field_count(conn) > 0 then begin
   Print_Mysql_Error;    // c'est bien une erreur
   exit;
  end
  else  memo1.lines.add('commande xecute par le serveur : '+
                       inttostr(mysql_affected_rows(conn))+' lignes affectes');
  exit;
 end;

 // traitement de la requte
 memo1.Lines.add(' In process....');
 if not process_result_set(res_set) then Print_Mysql_Error
  else memo1.Lines.add('Ok '+inttostr(mysql_num_rows(res_set)) +
                       ' lignes receptionnes');

memo2.clear;
memo1.lines.add('=======================================');
mysql_free_result(res_set); // toujours librer la memoire aprs une requte
// surtout si il xige d'importante ressource pour les donnes rceptionnes !
end;


procedure TForm1.effacerlechapquery1Click(Sender: TObject);
begin
memo2.clear;
end;


procedure TForm1.effacerlechamp1Click(Sender: TObject);
begin
memo1.clear;
end;

procedure TForm1.Label10Click(Sender: TObject);
begin
panel1.visible:=false;
end;

procedure TForm1.Show1Click(Sender: TObject);
begin
panel1.visible:=true;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
Selection_Row:=Stringgrid1.cells[Acol,Arow];
if Selection_row='' then exit;
Clipboard.Clear;
Clipboard.AsText:=Selection_Row;
end;

procedure TForm1.StringGrid1DblClick(Sender: TObject);
begin
if Selection_Row <> '' then
 MessageDlg('Your selection : '+Selection_Row, mtinformation,  [mbOk], 0);
end;

procedure TForm1.RefreshLog1Click(Sender: TObject);
begin
if not connection then begin
   MessageDlg('Le serveur Mysql est dconnect.', mtError,
      [mbOk], 0);
 exit;
 end;

 if Mysql_refresh(conn,REFRESH_LOG) <> 0 then
  print_Mysql_error //('Commande invalide: REFRESH_LOG ');
  // l'erreur la plus classique comme pour les requtes ci dessous est qu'il
  // faut une autorisation pour que le serveur Mysql les executes Grant[....].
 else memo1.lines.add(' Commande Refresh_Log Ok ');
end;

procedure TForm1.RefreshTables1Click(Sender: TObject);
begin
if not connection then begin
   MessageDlg('Le serveur Mysql est dconnect.', mtError,
      [mbOk], 0);
 exit;
 end;

 if Mysql_refresh(conn,REFRESH_TABLES) <> 0 then
  print_Mysql_error //('Commande invalide: REFRESH_TABLES ');
 else memo1.lines.add(' Commande Refresh_Tables Ok ');
end;

procedure TForm1.RefreshHosts1Click(Sender: TObject);
begin
if not connection then begin
   MessageDlg('Le serveur Mysql est dconnect.', mtError,
      [mbOk], 0);
 exit;
 end;

 if Mysql_refresh(conn,REFRESH_HOSTS) <> 0 then
  print_Mysql_error //('Commande invalide: REFRESH_HOSTS ');
 else memo1.lines.add(' Commande Refresh_Hosts Ok ');
end;

procedure TForm1.RefreshStatus1Click(Sender: TObject);
begin
if not connection then begin
   MessageDlg('Le serveur Mysql est dconnect.', mtError,
      [mbOk], 0);
 exit;
 end;

 if Mysql_refresh(conn,REFRESH_STATUS) <> 0 then
  print_Mysql_error //('Commande invalide: REFRESH_STATUS ');
 else memo1.lines.add(' Commande Refresh_Status Ok ');
end;

//ouvrir le fichier d'aide page sommaire
procedure TForm1.Help1Click(Sender: TObject);
begin
//Application.helpfile:='mysql_1.hlp';
//-> inclus dans la source [projet|voir le source]
Application.HelpJump('Sommaire');
end;

end.
